{{- range $name, $values := .Values.rbac }}
---
apiVersion: v1
kind: ServiceAccount
metadata:
  name: {{ $name }}-admin
  namespace: {{ $values.namespace }}
---
apiVersion: v1
kind: Secret
metadata:
  name: {{ $name }}-admin-token
  namespace: {{ $values.namespace }}
  annotations:
    kubernetes.io/service-account.name: {{ $name }}-admin
type: kubernetes.io/service-account-token
---
apiVersion: rbac.authorization.k8s.io/v1
kind: Role
metadata:
  name: {{ $name }}:admin
  namespace: {{ $values.namespace }}
rules:
  - apiGroups:
    {{- range $values.apiGroups }}
    - "{{ . }}"
    {{- end }}
    resources:
    {{- range $values.resources }}
    - "{{ . }}"
    {{- end }}
    verbs:
    {{- range $values.verbs }}
    - "{{ . }}"
    {{- end }}
---
apiVersion: rbac.authorization.k8s.io/v1
kind: RoleBinding
metadata:
  name: {{ $name }}-admin
  namespace: {{ $values.namespace }}
roleRef:
  apiGroup: rbac.authorization.k8s.io
  kind: Role
  name: {{ $name }}:admin
subjects:
  - apiGroup: ""
    kind: ServiceAccount
    name: {{ $name }}-admin
    namespace: {{ $values.namespace }}
{{- end }}
